<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );
require_once (JPATH_SITE . DS . 'components' . DS . 'com_abook' . DS . 'helpers' . DS . 'route.php');

class xmap_com_abook {
	function prepareMenuItem(&$node,&$params) {
		$link_query = parse_url( $node->link );
		parse_str( html_entity_decode($link_query['query']), $link_vars);
		$view = JArrayHelper::getValue( $link_vars, 'view', '' );
		$gid = intval(JArrayHelper::getValue($link_vars,'gid',0));
		if ( $view == 'search'){
			$node->uid = 'com_abooks'.$gid;
                        $node->expandible = false;
			//$node->expandible = false;
			//return true;
		}
		if ( $view == 'author'){
                        $node->uid = 'com_abooka'.$gid;
                        $node->expandible = true;
		}
	
		if ( $view == 'book'){
                        $node->uid = 'com_abookb'.$gid;
                        $node->expandible = true;
                }

		if ( $view == 'category'){
                        $node->uid = 'com_abookc'.$gid;
                        $node->expandible = true;
                }
	}

	function &getTree( &$xmap, &$parent, &$params ) {
		//global $mosConfig_absolute_path;
		$list = array();
		if ( strpos($parent->link, 'view=book') ) {
			return $list;
		}
		if (strpos($parent->link, 'view=search') ) {
			$notexpand=true;
                        return $notexpand;   // Do not expand links to posts
                }
		$link_query = parse_url( $parent->link );

                parse_str( html_entity_decode($link_query['query']), $link_vars );
		if (strpos($parent->link, 'view=category') || strpos($parent->link, 'view=categories')) {
	                $catid = JArrayHelper::getValue($link_vars,'id',0);
			$list = xmap_com_abook::getCategorieTree ( $xmap, $parent, $catid, $params);
		}
		if (strpos($parent->link, 'view=author')) {
			if($params['show_book']=="true"){
				$authorid = JArrayHelper::getValue($link_vars,'id');
				$list = xmap_com_abook::getBooksAuthor( $xmap, $parent, $authorid, $params);
			}
		}
		return $list;
	}
	function getBooks(&$xmap, &$parent, &$catid ,&$params,$subcatid)
	{
		if($params['orderby']){
			$orderby =$params['orderby'];
		}else{
			$orderby='title';
		}
		$xmap->changeLevel(1);
		$database = &JFactory::getDBO();
		$query="SELECT a.id, a.title, a.catid, ".
			"\n CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(':', a.id, a.alias) ELSE a.id END as slug, ". 
			"\n CASE WHEN CHAR_LENGTH(b.alias) THEN CONCAT_WS(':', b.id, b.alias) ELSE b.id END as catslug ".
			"FROM #__abbook AS a ".
			"JOIN #__abcategories AS b ON b.id=a.catid ".
			"WHERE a.published = '1' ".
			"AND b.published = '1' ".
			"AND catid =$subcatid ".
			"ORDER BY ".$orderby;
		$database->setQuery ($query);
		$books = $database->loadObjectList();

			foreach($books as $book) 
			{
				$node = new stdclass;
				$node->id   = $parent->id;
				$node->uid=$parent->uid.'b'.$book->id;
				$node->name = $book->title;
				$node->parent=1;
				$node->browserNav="";//open new window
				$node->ordering=2;
				$node->priority=$parent->priority;
				//$node->changefreq=$parent->changefreq;
				$node->type='component';
				$node->menutype='mainmenu';
				//$node->link ='index.php?option=com_abook&amp;view=book&amp;catid=' .$book->catid.'&amp;id='.$book->id;
				$node->link =AbookHelperRoute::getBookRoute($book->slug, $book->catslug);
				$xmap->printNode($node);
			}
		$xmap->changeLevel(-1);
	}
	function getSubCategory(&$xmap, &$parent, &$catid ,&$params,$parentid,$cats)
	{
		$xmap->changeLevel(1);
		foreach($cats as $subcat)
		{
			if($subcat->parent_id==$parentid)
			{
				$node = new stdclass;
				$node->id   = $parent->id;
				$node->uid=$parent->uid.'c'.$subcat->id;
				$node->name = $subcat->title;
				$node->parent=1;
				$node->browserNav="";
				$node->ordering=2;
				$node->priority=$parent->priority;
				$node->chansefreq=$parent->changefreq;
				$node->type='component';
				//$node->link = 'index.php?option=com_abook&amp;view=category&amp;id='.$subcat->id;
				$node->link =AbookHelperRoute::getCategoryRoute($subcat->slug);
				$xmap->printNode($node);
				xmap_com_abook::getSubCategory($xmap, $parent, $catid ,$params,$subcat->id,$cats);
				if($params['show_book']=="true"){
					xmap_com_abook::getBooks ($xmap, $parent, $catid ,$params,$subcat->id);
				}
			}
		}
		$xmap->changeLevel(-1);
	}

	function getCategorieTree ( &$xmap, &$parent, &$catid ,&$params) {
		//global $my,$mosConfig_absolute_path;
		$database = &JFactory::getDBO();
		$list = array();
		$query="SELECT id, title, name, parent_id, ".
			"\n CASE WHEN CHAR_LENGTH(alias) THEN CONCAT_WS(':', id, alias) ELSE id END as slug ".
			"FROM #__abcategories ".
			"WHERE published = '1' ".
			"AND access<='0' ".
			"ORDER BY parent_id,ordering";
		$database->setQuery($query);
		$cats = $database->loadObjectList();
		xmap_com_abook::getSubCategory($xmap, $parent, $catid ,$params,$catid,$cats);
		xmap_com_abook::getBooks ($xmap, $parent, $catid ,$params,$catid);
	}

	function getBooksAuthor (&$xmap, &$parent, &$authorid ,&$params){
		$database = &JFactory::getDBO();
                $list = array();
		$query="SELECT b.id, b.title, b.catid, ".
			"\n CASE WHEN CHAR_LENGTH(b.alias) THEN CONCAT_WS(':', b.id, b.alias) ELSE b.id END as slug, ".
                        "\n CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(':', c.id, c.alias) ELSE c.id END as catslug ". 
			"FROM jos_abbookauth AS a ".
			"JOIN #__abbook AS b ON a.idbook=b.id ".
			"JOIN #__abcategories AS c ON c.id=b.catid ".
			"WHERE b.published = '1' ".
			"AND b.access<='0' ".
			"AND a.idauth=".$authorid." ".
			"ORDER BY b.title";
		$database->setQuery($query);
		$books = $database->loadObjectList();
		$xmap->changeLevel(1);
		foreach($books as $book)
                        {
                                $node = new stdclass;
                                $node->id   = $parent->id;
                                $node->uid=$parent->uid.'a'.$book->id;
                                $node->name = $book->title;
                                $node->parent=1;
                                $node->browsNav=1;//open new window
                                $node->ordering=2;
                                $node->priority=$parent->priority;
                                //$node->changefreq=$parent->changefreq;
                                $node->type='component';
                                $node->menutype='mainmenu';
                                //$node->link ='index.php?option=com_abook&amp;view=book&amp;catid=' .$book->catid.'&amp;id='.$book->id;
				$node->link =AbookHelperRoute::getBookRoute($book->slug, $book->catslug);
                                $xmap->printNode($node);
                        }
                $xmap->changeLevel(-1);
	}
}
